diff --git i/src/Makefile w/src/Makefile
index 0d4a6ee..a8d4e4b 100644
--- i/src/Makefile
+++ w/src/Makefile
@@ -26,6 +26,8 @@ SUBDIRS = \
 	makefiles \
 	test/regress
 
+.NOTPARALLEL:
+
 $(recurse)
 
 install: install-local
diff --git i/src/interfaces/Makefile w/src/interfaces/Makefile
index 2c034bc..9fe368e 100644
--- i/src/interfaces/Makefile
+++ w/src/interfaces/Makefile
@@ -15,3 +15,5 @@ include $(top_builddir)/src/Makefile.global
 SUBDIRS = libpq ecpg
 
 $(recurse)
+
+all-ecpg-recurse: all-libpq-recurse
diff --git i/src/interfaces/ecpg/Makefile w/src/interfaces/ecpg/Makefile
index d955cee..ca434c8 100644
--- i/src/interfaces/ecpg/Makefile
+++ w/src/interfaces/ecpg/Makefile
@@ -6,7 +6,8 @@ SUBDIRS = include pgtypeslib ecpglib compatlib preproc
 
 $(recurse)
 
-all-compatlib-recursive: all-ecpglib-recursive
+all-compatlib-recurse: all-ecpglib-recurse
+all-ecpglib-recurse: all-pgtypeslib-recurse
 
 clean distclean maintainer-clean:
 	$(MAKE) -C test clean
